/*H**************************************************************************
* $RCSfile: eep_drv.h,v $         
*----------------------------------------------------------------------------
* Copyright (c) 2003 Atmel.
*----------------------------------------------------------------------------
* RELEASE:      $Name: avr-can11-lib-mcu-0_0_3 $      
* REVISION:     $Revision: 1.1.2.1 $     
* FILE_CVSID:   $Id: eep_drv.h,v 1.1.2.1 2004/03/30 06:08:41 jberthy Exp $       
*----------------------------------------------------------------------------
* PURPOSE: 
* Include file for EEPROM API
*****************************************************************************/
#ifndef _EEP_DRV_H
#define _EEP_DRV_H

/*_____ I N C L U D E S ____________________________________________________*/

/*_____ M A C R O S ________________________________________________________*/
#define Enable_eeprom()

#define Disable_eeprom()

/*M**************************************************************************
* NAME: eeprom_busy 
*----------------------------------------------------------------------------
* PARAMS:  
*----------------------------------------------------------------------------
* PURPOSE: 
* Gives the status of EEPROM
*****************************************************************************/
#define eeprom_busy()  (EECR &(1<<EEWE))

/*M**************************************************************************
* NAME: eeprom_wr 
*----------------------------------------------------------------------------
* PARAMS:  
* addr: EEPROM address 
* val: Data value to write in the EEPROM.
*----------------------------------------------------------------------------
* PURPOSE: 
* Writes a byte in the EEPROM memory.
*****************************************************************************/
#define eeprom_wr(addr,b) (EEAR=addr, EEDR=b, EECR |= (1<<EEMWE),EECR |= (1<<EEWE))


extern Byte eeprom_rd(Uint16 addr);


/*_____ D E F I N I T I O N S ______________________________________________*/

/*_____ D E C L A R A T I O N S ____________________________________________*/

#endif  /* _EEPROM_H */

