/*C**************************************************************************
* $RCSfile: eep_lib.c,v $
*----------------------------------------------------------------------------
* Copyright (c) 2003 Atmel.
*----------------------------------------------------------------------------
* RELEASE:      $Name: avr-can11-lib-mcu-0_0_3 $      
* REVISION:     $Revision: 1.1 $     
* FILE_CVSID:   $Id: eep_lib.c,v 1.1 2004/03/29 11:24:43 jberthy Exp $       
*----------------------------------------------------------------------------
* PURPOSE: 
* This file contains C functions to control:
* EEPROM
*****************************************************************************/

/*_____ I N C L U D E S ____________________________________________________*/
#define _EEP_LIB_C_
#include "config.h"
#include "eep_drv.h"
#include "eep_lib.h"

/*_____ M A C R O S ________________________________________________________*/

/*_____ D E F I N I T I O N S ______________________________________________*/
#ifndef EEPROM_SIZE
#error You must define EEPROM_SIZE in bytes in config.h
#else


bit eeprom_erase(void)
{
#if EEPROM_SIZE > 0
register Uint16 addr;

Enable_eeprom();
addr=0;
do {
  while (eeprom_busy());
  eeprom_wr(addr,EEPROM_BLANK_VALUE);
  } while (addr++!=(EEPROM_SIZE-1));
Disable_eeprom();
#endif
return TRUE;
}

bit eeprom_wr_byte (Uint16 addr, Uchar value)
{
Enable_eeprom();
while (eeprom_busy());
eeprom_wr(addr,value);
Disable_eeprom();
return TRUE;
} 


Byte eeprom_rd_byte (Uint16 addr)
{
register Byte b;
  while (eeprom_busy());
Enable_eeprom();
b=eeprom_rd(addr);
Disable_eeprom();
return b;
} 



bit eeprom_rd_block (Uint16 src, Byte _MemType_* dest, Byte n)
{
  while (eeprom_busy());
Enable_eeprom();
for (;n--;++src) *dest++=eeprom_rd(src);
Disable_eeprom();
return TRUE;
}



bit eeprom_wr_block (Byte _MemType_* src, Uint16 dest, Byte n)
{
#if EEPROM_SIZE > 0

Enable_eeprom();
for (;n--;)
  {
  while (eeprom_busy());
  eeprom_wr(dest,*src++);
  if (dest++==(EEPROM_SIZE-1)) break; // page not aligned on boundary EEPROM memory block
  } 
Disable_eeprom();
#endif
return TRUE;
}

#endif

