/*C**************************************************************************
* $RCSfile: main.c,v $
*----------------------------------------------------------------------------
* Copyright (c) 2002 Atmel.
*----------------------------------------------------------------------------
* RELEASE:      $Name: avr-can11-lib-mcu-0_0_3 $      
* REVISION:     $Revision: 1.2 $     
* FILE_CVSID:   $Id: main.c,v 1.2 2004/03/31 06:01:57 jberthy Exp $       
*----------------------------------------------------------------------------
* PURPOSE: 
* This file contains an example of use the SPI library
* 
*****************************************************************************/

/*_____ I N C L U D E S ____________________________________________________*/

#include "config.h"
#include "lib_mcu\uart\uart_lib.h"



/*_____ M A C R O S ________________________________________________________*/

/*_____ D E F I N I T I O N S ______________________________________________*/
/*V**************************************************************************
* NAME: txt_logo_atmel
*define----------------------------------------------------------------------------
* PURPOSE: 
* Add some bytes of code for standard logo string.
* If LOGO_ATMEL is defined: ASCII Art of Atmel Logo + Release name
* Else: Release name
*----------------------------------------------------------------------------
* NOTE: 
* CODE_MEM (memory location identifier) to be defined
*****************************************************************************/
char _ConstType_ txt_logo_atmel[]="\n\
        _____________________________\n\
      /___   ________________________|\n\
     ___  | |  ________    ____   _\n\
    /   | | | |  _   _ \\  |  __| | |\n\
   / /| | | | | | | | | | | |__  | |\n\
  / / | | | | | | | | | | |  __| | |\n\
 / /_ | | | | | | | | | | | |__  | |__\n\
/____||_| |_| |_| |_| |_| |____| |___/\n\
 ___________________________________\n\
|__________________________________/ (R)\n\
$Name: avr-can11-lib-mcu-0_0_3 $\n\n";

/*_____ D E C L A R A T I O N S ____________________________________________*/

/*F**************************************************************************
* NAME: uart_puts
*----------------------------------------------------------------------------
* PARAMS:   
* sz: string zero terminated to print on UART
* return: none
*----------------------------------------------------------------------------
* PURPOSE:
* print a string on the UART
*----------------------------------------------------------------------------
* EXAMPLE:
*----------------------------------------------------------------------------
* NOTE: 
* This function was added only to optimized uart_splash & uart_clrscr in VT100
* mode (reduce code size).
*----------------------------------------------------------------------------
* REQUIREMENTS: 
*****************************************************************************/
void uart_puts (char _GenericType_ * sz)
{
register char   ch;

for (;ch=*sz++;)
  {
  if (ch=='\n') uart_putchar('\r');
  uart_putchar(ch);
  }
uart_putchar('\r');
uart_putchar('\n');
}



bit state_uart_splash=0;

/*F**************************************************************************
* NAME: uart_splash
*----------------------------------------------------------------------------
* PARAMS:   
* return: TRUE if terminated
*----------------------------------------------------------------------------
* PURPOSE:
* Splash screen
*----------------------------------------------------------------------------
* EXAMPLE:
*----------------------------------------------------------------------------
* NOTE: 
*----------------------------------------------------------------------------
* REQUIREMENTS: 
*****************************************************************************/
bit uart_splash (void)
{
if (!state_uart_splash)
  {
  uart_puts(txt_logo_atmel);
  }
return state_uart_splash=TRUE;
}



/*F**************************************************************************
* NAME: main 
*----------------------------------------------------------------------------
* PARAMS:   none
* return:   none
*----------------------------------------------------------------------------
* PURPOSE: 
*----------------------------------------------------------------------------
* EXAMPLE:
*----------------------------------------------------------------------------
* NOTE: 
*----------------------------------------------------------------------------
* REQUIREMENTS: 
*****************************************************************************/
void main (void)
{	
  uart_init();

  putchar (0x55);

  uart_splash();

  while(1);
 }

